#ifndef __MYXLCD_H
#define __MYXLCD_H

#include "GenericTypeDefs.h"
#include "p18f4550.h"

#define DATA_PORT_0   PORTDbits.RD7
#define DATA_PORT_1   PORTDbits.RD6
#define DATA_PORT_2   PORTDbits.RD5
#define DATA_PORT_3   PORTDbits.RD4
#define DATA_PORT_4   PORTDbits.RD3
#define DATA_PORT_5   PORTDbits.RD2
#define DATA_PORT_6   PORTDbits.RD0
#define DATA_PORT_7   PORTDbits.RD1

#define TRIS_DATA_PORT_0   TRISDbits.TRISD7
#define TRIS_DATA_PORT_1   TRISDbits.TRISD6
#define TRIS_DATA_PORT_2   TRISDbits.TRISD5
#define TRIS_DATA_PORT_3   TRISDbits.TRISD4
#define TRIS_DATA_PORT_4   TRISDbits.TRISD3
#define TRIS_DATA_PORT_5   TRISDbits.TRISD2
#define TRIS_DATA_PORT_6   TRISDbits.TRISD0
#define TRIS_DATA_PORT_7   TRISDbits.TRISD1


#define my_data_port_eq(X) my_set_data_port(X)
#define my_tris_data_port_eq(X) my_set_tris_data_port(X)

// DATA_PORT = data;               // Write data to port
void my_set_data_port(BYTE value);

// DATA_PORT = data;               // Write data to port
void my_set_tris_data_port(BYTE value);

BYTE my_get_data_port(void);

BYTE my_get_tris_data_port(void);
   
// TRIS_DATA_PORT &= 0x0f;  
void my_tris_data_port_andeq(BYTE value);

// TRIS_DATA_PORT &= 0x0f;  
void my_data_port_andeq(BYTE value);
 
// TRIS_DATA_PORT |= 0x0f;  
void my_tris_data_port_oreq(BYTE value);


// TRIS_DATA_PORT |= 0x0f;  
void my_data_port_oreq(BYTE value);   

 
// TRIS_DATA_PORT | 0x0f;  
BYTE my_tris_data_port_or(BYTE value);


// TRIS_DATA_PORT |= 0x0f;  
BYTE my_data_port_or(BYTE value);


// TRIS_DATA_PORT & 0x0f;  
BYTE my_tris_data_port_and(BYTE value);


// TRIS_DATA_PORT |= 0x0f;  
BYTE my_data_port_and(BYTE value);  
 


#endif
